/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <syslog.h>
#include "struct.h"

static char *level[]= {
	"LOG_EMERG",
	"LOG_ALERT",
	"LOG_CRIT",
	"LOG_ERR",
	"LOG_WARNING",
	"LOG_NOTICE",
	"LOG_INFO",
	"LOG_DEBUG"
};

static workp works=(workp)0;

void setMyLog( workp work ) {
	works=work;
}
void my_syslog( const char *file, int line, int priority, const char* format, ... ) {

	va_list ap;
	static FILE *fp=NULL;
	time_t now;
	time(&now);

	if( works && works->setup && works->setup->debug/2 < priority ) {
		return;
	}
	if( !fp ) {
		fp=fopen( "tmp/EladRemote.log", "a" );
	}
	fprintf( fp, "%s ", strtok( ctime( &now ), "\n" ) );
	fprintf( fp, "%-15.15s %5d ", file, line );
	fprintf( fp, "%s ", level[priority] );
	va_start( ap, format );
	vfprintf( fp, format, ap );
	va_end( ap );
	fprintf( fp, "\n" );
	fflush( fp );
	if( works && works->setup && works->setup->debug%2 ) {
		va_start( ap, format );
		vsyslog( priority, format, ap );
		va_end( ap );
	}
	if( priority==LOG_DEBUG || (works && works->setup && works->setup->debug/2 == 10 ) ) {
		va_start( ap, format );
		vfprintf( stderr, format, ap );
		va_end( ap );
		if( priority!=LOG_DEBUG && (works && works->setup && works->setup->debug/2 == 10 ) ) {
			fprintf( stderr, "\n" );
		} 
		fflush( stderr );
	}
}
